from pylab import *

rc('text', usetex = True)
rc('font', family = 'serif')
rc('font', size = 12)
rcParams['text.latex.preamble']=[r'\usepackage{amsmath}']



def continualize(x):
    n = len(x)
    for i in range(n - 1):
        if x[i + 1] - x[i] < - 6: # somewhat arbitrary
            for j in range(i + 1, n):
                x[j] += 2 * pi
        elif x[i + 1] - x[i] > 6: # somewhat arbitrary
            for j in range(i + 1, n):
                x[j] -= 2 * pi
    return x



R = 5
deg = linspace(0, 360, 361)
theta = radians(deg)
z1 = R * exp(1j * theta)


def f(z):
    tmpf = z
    #tmpf = z**5
    #tmpf = 1 / z
    #tmpf = 1 / z**5
    #tmpf =  (z - 4) / (z - 2)**4
    #tmpf = z + 40
    #tmpf = z - 40
    #tmpf = (z - 3) / (z - 4)
    #tmpf = z + 6
    #tmpf = z + 5
    #tmpf = 1 / (z + 5)
    #tmpf = 1 / (z**2 + 25)
    #tmpf = 1 / (z**2 + 16)
    #tmpf = z / (z**2 + 16)
    #tmpf = 1 / (z**2 + 36)
    #tmpf = (z - 1) * (z + 7) * (z - 1j) * (z + 1j) / (z**4 * (z - 8) * (z + 2j) * (z - 2j))
    return tmpf
    
z2 = array(list(map(f, z1)))

r = abs(z2)
rho = log(r)
phi = degrees(continualize(angle(z2)))
#phi = degrees((angle(z2)))

zmp = int(round((phi[-1] - phi[0]) / 360))
print()
print('Z - P = {:d}'.format(zmp))
print()

close('all')


figure(1)

subplot(2, 1, 1)
plot(deg, rho)
ylabel(r'$\rho$')
xlim(0, 360)
grid(True)

subplot(2, 1, 2)
plot(deg, phi / 360)
ylabel(r'$\varphi / 360^\circ$')
xlabel(r'$\theta \; [^\circ]$')
xlim(0, 360)
xticks(linspace(0, 360, 360 / 30 +1))
grid(True)

figure(2, figsize = (6, 6))

mr = max(r)
plot(r * cos(radians(phi)), r * sin(radians(phi)))
plot(0, 0, 'r+')
xlim(-mr, mr)
ylim(-mr, mr)
xlabel(r'$\Re(z_2)$')
ylabel(r'$\Im(z_2)$')
grid(True)


show()



